#property show_inputs

extern string Pair1  = "EURUSD1.csv";
extern string Pair2  = "AUDUSD1.csv";
extern string Output = "EURAUD1.csv";
extern int    DIGITS = 5;

int           Pair1FileHandle;
int           Pair2FileHandle;
int           OutputFileHandle;

string        OutputBuffer;

string        Pair1CurrentTimeDate;
string        Pair1CurrentTimeMinutes;
datetime      Pair1CurrentTime;
double        Pair1CurrentOpen;
double        Pair1CurrentHigh;
double        Pair1CurrentLow;
double        Pair1CurrentClose;
int           Pair1CurrentVolume;

string        Pair2CurrentTimeDate;
string        Pair2CurrentTimeMinutes;
datetime      Pair2CurrentTime;
double        Pair2CurrentOpen;
double        Pair2CurrentHigh;
double        Pair2CurrentLow;
double        Pair2CurrentClose;
int           Pair2CurrentVolume;

datetime      OutputTime;
double        OutputOpen;
double        OutputHigh;
double        OutputLow;
double        OutputClose;
int           OutputVolume;


//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
int OnStart()
{
    Pair1FileHandle  = FileOpen(Pair1, FILE_SHARE_READ | FILE_CSV, ",");
    OutputFileHandle = FileOpen(Output, FILE_BIN | FILE_READ | FILE_WRITE);

    while (0 < 1)
    {
        Pair1CurrentTimeDate    = FileReadString(Pair1FileHandle);
        Pair1CurrentTimeMinutes = FileReadString(Pair1FileHandle);
        Pair1CurrentTime        = StringToTime(Pair1CurrentTimeDate + " " + Pair1CurrentTimeMinutes);
        Pair1CurrentOpen        = StrToDouble(FileReadString(Pair1FileHandle));
        Pair1CurrentHigh        = StrToDouble(FileReadString(Pair1FileHandle));
        Pair1CurrentLow         = StrToDouble(FileReadString(Pair1FileHandle));
        Pair1CurrentClose       = StrToDouble(FileReadString(Pair1FileHandle));
        Pair1CurrentVolume      = StrToInteger(FileReadString(Pair1FileHandle));

        if (ReadPair2(Pair1CurrentTime) == Pair1CurrentTime)
        {
            OutputTime   = (Pair1CurrentTime + Pair2CurrentTime) / 2;
            OutputOpen   = Pair1CurrentOpen / Pair2CurrentOpen;
            OutputHigh   = Pair1CurrentHigh / Pair2CurrentHigh;
            OutputLow    = Pair1CurrentLow / Pair2CurrentLow;
            OutputClose  = Pair1CurrentClose / Pair2CurrentClose;
            OutputVolume = (Pair1CurrentVolume + Pair2CurrentVolume) / 2;

            OutputBuffer = TimeToStr(OutputTime, TIME_DATE) + "," + TimeToStr(OutputTime, TIME_MINUTES) + "," + DoubleToStr(OutputOpen, DIGITS) + "," + DoubleToStr(OutputHigh, DIGITS) + "," + DoubleToStr(OutputLow, DIGITS) + "," + DoubleToStr(OutputClose, DIGITS) + "," + DoubleToStr(OutputVolume, 0) + "\n";

            FileWriteString(OutputFileHandle, OutputBuffer, StringLen(OutputBuffer));
        }

        if (FileIsEnding(Pair1FileHandle) == TRUE)
        {
            FileClose(Pair1FileHandle);

            FileFlush(OutputFileHandle);
            FileClose(OutputFileHandle);

            return(0);
        }
    }
    return(0);
}
//+------------------------------------------------------------------+

int ReadPair2(datetime DestinationTime)
{
    Pair2FileHandle = FileOpen(Pair2, FILE_SHARE_READ | FILE_CSV, ",");

    Pair2CurrentTime = 0;

    while (Pair2CurrentTime != DestinationTime && FileIsEnding(Pair2FileHandle) == FALSE)
    {
        Pair2CurrentTimeDate    = FileReadString(Pair2FileHandle);
        Pair2CurrentTimeMinutes = FileReadString(Pair2FileHandle);
        Pair2CurrentTime        = StringToTime(Pair2CurrentTimeDate + " " + Pair2CurrentTimeMinutes);
        Pair2CurrentOpen        = StrToDouble(FileReadString(Pair2FileHandle));
        Pair2CurrentHigh        = StrToDouble(FileReadString(Pair2FileHandle));
        Pair2CurrentLow         = StrToDouble(FileReadString(Pair2FileHandle));
        Pair2CurrentClose       = StrToDouble(FileReadString(Pair2FileHandle));
        Pair2CurrentVolume      = StrToInteger(FileReadString(Pair2FileHandle));
    }

    FileClose(Pair2FileHandle);

    return(Pair2CurrentTime);
}
